// AddSubBlend.cpp : AvP[Vp̃Gg |Cg̒`
//

#include "stdafx.h"

#include "SDIB32GL.H"
#include "util.h"

LPSDIB32GL lpBack	= NULL;
LPSDIB32GL lpBg		= NULL;
LPSDIB32GL lpSprite = NULL;


int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow )
{
 	// TODO: ̈ʒuɃR[hLqĂB

	MyRegisterClass( hInstance );

	if( !InitInstance( hInstance, nCmdShow ) )
	{
		return FALSE;
	}


	// MMX̔
	BOOL bMMX = SDIB32GL_IsMMX();

	const CLSID* pUse_CLSID;

	if( bMMX )
	{
		pUse_CLSID = &CLSID_SDib32GLPMMX;

	}else
	{
		pUse_CLSID = &CLSID_SDib32GLX86;
	}
	
	HRESULT hr;

	try
	{
		// obNobt@̍쐬
		hr = SDIB32GL_CreateBuffer( 
			CLIENT_WIDTH, CLIENT_HEIGHT, SDIB32GL_BLUE, NULL,
			*pUse_CLSID, IID_ISDib32GL, (LPVOID*)&lpBack );

		if( FAILED( hr ) )
		{
			throw exception("obNobt@̍쐬Ɏs");
		}

		// BGǂݍ
		hr = SDIB32GL_LoadFromFile(
			"../Media/BackGround.bmp", 0, NULL,
			*pUse_CLSID, IID_ISDib32GL, (LPVOID*)&lpBg );

		if( FAILED( hr ) )
		{
			throw exception("t@C̓ǂݍ݂Ɏs");
		}

		// XvCgǂݍ
		hr = SDIB32GL_LoadFromFile(
			"../Media/AddSubBlend.bmp", SDIB32GL_RGB(0,255,0), NULL,
			*pUse_CLSID, IID_ISDib32GL, (LPVOID*)&lpSprite );

		if( FAILED( hr ) )
		{
			throw exception("t@C̓ǂݍ݂Ɏs");
		}
	}


	// G[
	catch( exception& e )
	{
		
		MessageBox( hWnd, e.what(), szTitle, MB_OK | MB_ICONSTOP );

		if( lpSprite ){	lpSprite->Release(); lpSprite = NULL; }
		if( lpBg ){		lpBg->Release(); lpBg = NULL; }
		if( lpBack ){	lpBack->Release(); lpBack = NULL; }

		return FALSE;
	}

	// bZ[W[v(C[`)
	MSG msg;

	SIZE size = {lpSprite->GetWidth(), lpSprite->GetHeight()};

	int x = (CLIENT_WIDTH-500)/2;
	int y = (CLIENT_HEIGHT-375)/2;
	int add_x = (500-size.cx)/3;
	int add_y = (375-size.cy)/1;

	for(;;)
	{
		if( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) )
		{
			if( msg.message == WM_QUIT ) break;

			TranslateMessage( &msg );
			DispatchMessage( &msg );

		}else
		{

			// obNobt@NA
			//lpBack->Clear( SDIB32GL_RGB(150,220,255) );
			lpBack->Blt( lpBg, 0, 0, NULL, NULL, NULL );

			
			POINT mouse;
			GetCursorPos( &mouse );
			ScreenToClient( hWnd, &mouse );
			
			int d = 255-(int)sqrt(
				((CLIENT_WIDTH_H-mouse.x)*(CLIENT_WIDTH_H-mouse.x)+
				(CLIENT_HEIGHT_H-mouse.y)*(CLIENT_HEIGHT_H-mouse.y)))/2;

			if( d > 255 ) d = 255;
			else if( d < 0 ) d = 0;

			// obNobt@ɉZZ]
			for( int i = 0; i < 2; i++ )
			{
				if( i == 0 )
					lpBack->AddBlendBlt( lpSprite, x+add_x*i, y+add_y*i, &size, NULL, &size );
				else
					lpBack->AddAlphaBlendBlt( lpSprite, x+add_x*i, y+add_y*i, &size, NULL, &size, d );
			}

			for( i = 0; i < 2; i++ )
			{
				if( i == 0 )
					lpBack->SubBlendBlt( lpSprite, x+add_x*(i+2), y+add_y*i, &size, NULL, &size );
				else
					lpBack->SubAlphaBlendBlt( lpSprite, x+add_x*(i+2), y+add_y*i, &size, NULL, &size, d );
			}


			// FPSAMMXAo[W̕`
			DrawSDib32GLInfo( lpBack );

			// ĕ`
			InvalidateRect( hWnd, NULL, FALSE );
			UpdateWindow( hWnd );
		}
	}


	// BGobt@̉
	lpBg->Release();
	lpBg = NULL;

	// XvCgobt@̉
	lpSprite->Release();
	lpSprite = NULL;

	// obNobt@̉
	lpBack->Release();
	lpBack = NULL;

	return msg.wParam;
}


//
// ʂ̃tbV
//
void OnRefresh( HDC hdc )
{
	if( lpBack == NULL ) return;

	BitBlt( hdc, 0, 0, CLIENT_WIDTH, CLIENT_HEIGHT, 
		lpBack->GetDC(), 0, 0, SRCCOPY );
}

