
#include "stdafx.h"

#include <initguid.h>
#include "SDIB32GL.H"
#include "fpstimer.h"
#include "util.h"

#define WINDOW_STYLE	WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX | WS_POPUP | WS_VISIBLE
#define WINDOW_CLASS	"SDIB32GLSampleApp"

HINSTANCE	hInst;
HWND		hWnd;
char		szTitle[256];
CFpsTimer	FpsTimer;


//
//  ֐: MyRegisterClass()
//
//  pr: EBhE NX̓o^
//
//  Rg:
//
//    ̊֐т̎gp͂̃R[h Windows 95 Őɒǉꂽ
//    'RegisterClassEx' ֐ Win32 VXě݊ێꍇ
//    ̂ݕKvƂȂ܂BAvP[VAAvP[VɊ֘At
//    ꂽX[ ACR擾ł悤Å֐ĂяoƂ
//    dvłB
//
ATOM MyRegisterClass( HINSTANCE hInstance )
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= 0;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= ::LoadIcon( NULL,IDI_APPLICATION );
	wcex.hCursor		= ::LoadCursor( NULL, IDC_ARROW );
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= WINDOW_CLASS;
	wcex.hIconSm		= NULL;

	return RegisterClassEx( &wcex );
}


//
//   ֐: InitInstance(HANDLE, int)
//
//   pr: CX^X nh̕ۑƃC EBhE̍쐬
//
//   Rg:
//
//        ̊֐ł́ACX^X nhO[oϐɕۑAvO
//        C EBhE쐬\܂B
//
BOOL InitInstance( HINSTANCE hInstance, int nCmdShow )
{

	hInst = hInstance; // O[oϐɃCX^X nhۑ܂

	RECT rc = { 0, 0, CLIENT_WIDTH, CLIENT_HEIGHT};
	AdjustWindowRect( &rc, WINDOW_STYLE, FALSE );

	LONG nWidth  = rc.right-rc.left;
	LONG nHeight = rc.bottom-rc.top;

	LONG nX = (GetSystemMetrics(SM_CXSCREEN)-nWidth)/2;
	LONG nY = (GetSystemMetrics(SM_CYSCREEN)-nHeight)/2;

	char szBuf[256];
	GetModuleFileName( hInstance, szBuf, 256 );
	_splitpath( szBuf, NULL, NULL, szTitle, NULL );

	hWnd = CreateWindow(WINDOW_CLASS, szTitle, WINDOW_STYLE,
      nX, nY, nWidth, nHeight, NULL, NULL, hInstance, NULL);

	if( !hWnd ) 
	{
		return FALSE;
	}

	ShowWindow( hWnd, nCmdShow );
	UpdateWindow( hWnd );

	return TRUE;
}


//
//  ֐: WndProc(HWND, unsigned, WORD, LONG)
//
//  pr: C EBhẼbZ[W܂B
//
//  WM_COMMAND	- AvP[V j[̏
//  WM_PAINT	- C EBhE̕`
//  WM_DESTROY	- IbZ[W̒ʒmƃ^[
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	PAINTSTRUCT ps;
	HDC hdc;

	switch( message ) 
	{
		case WM_PAINT:
			hdc = BeginPaint (hWnd, &ps);
			// TODO: ̈ʒuɕ`p̃R[hǉĂ...
			
			OnRefresh( hdc );

			EndPaint( hWnd, &ps );
			break;
		case WM_DESTROY:
			PostQuitMessage( 0 );
			break;
		default:
			return DefWindowProc( hWnd, message, wParam, lParam );
   }
   return 0;
}


//
//  ֐: DrawSDib32GLInfo( LPSDIB32GL lpBack )
//
//  pr: SDIB32GL̏`悵܂B
//
VOID DrawSDib32GLInfo( LPSDIB32GL lpBack )
{

	FpsTimer.WaitFrame();

	char szBuf[256];

	sprintf( szBuf, "FPS: %6.2f / MMX: %s / Version: %4.2f", 
		FpsTimer.GetFPS(FPSTIMER_F_FPS,true), SDIB32GL_IsMMX()?"YES":"NO", SDIB32GL_GetVersion()/100.f );

	SetBkMode( lpBack->GetDC(), TRANSPARENT );
	SetTextColor( lpBack->GetDC(), RGB(255,0,0) );
	TextOut( lpBack->GetDC(), 0, 0, szBuf, strlen(szBuf));
}