
#include "stdafx.h"

#include <initguid.h>
#include "../Common/SDIB32GL.H"
#include "../Common/fpstimer.h"
#include "DDUtil.h"

#define WINDOW_STYLE	WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX | WS_POPUP | WS_VISIBLE
#define WINDOW_CLASS	"SDIB32GLSampleApp"
#define DDRAW_MODE		(LPGUID)DDCREATE_EMULATIONONLY
#define DDRAW_MEMORYTYPE	(DDRAW_MODE!=(LPGUID)DDCREATE_EMULATIONONLY?DDSCAPS_VIDEOMEMORY:DDSCAPS_SYSTEMMEMORY)


HINSTANCE	hInst;
HWND		hWnd;
char		szTitle[256];
CFpsTimer	FpsTimer;
BOOL		bWindowed = 1;
RECT		rcClient;
RECT		rcWindow;
LPDIRECTDRAW7 lpDD = NULL;
LPDIRECTDRAWSURFACE7 lpDDSPrimary = NULL;
LPDIRECTDRAWSURFACE7 lpDDSBack = NULL;
LPDIRECTDRAWCLIPPER lpDDCliper = NULL;

//
//  ֐: MyRegisterClass()
//
//  pr: EBhE NX̓o^
//
//  Rg:
//
//    ̊֐т̎gp͂̃R[h Windows 95 Őɒǉꂽ
//    'RegisterClassEx' ֐ Win32 VXě݊ێꍇ
//    ̂ݕKvƂȂ܂BAvP[VAAvP[VɊ֘At
//    ꂽX[ ACR擾ł悤Å֐ĂяoƂ
//    dvłB
//
ATOM MyRegisterClass( HINSTANCE hInstance )
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= 0;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= ::LoadIcon( NULL,IDI_APPLICATION );
	wcex.hCursor		= ::LoadCursor( NULL, IDC_ARROW );
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= WINDOW_CLASS;
	wcex.hIconSm		= NULL;

	return RegisterClassEx( &wcex );
}


//
//   ֐: InitInstance(HANDLE, int)
//
//   pr: CX^X nh̕ۑƃC EBhE̍쐬
//
//   Rg:
//
//        ̊֐ł́ACX^X nhO[oϐɕۑAvO
//        C EBhE쐬\܂B
//
BOOL InitInstance( HINSTANCE hInstance, int nCmdShow )
{

	hInst = hInstance; // O[oϐɃCX^X nhۑ܂

	RECT rc = { 0, 0, CLIENT_WIDTH, CLIENT_HEIGHT};
	AdjustWindowRect( &rc, WINDOW_STYLE, FALSE );

	LONG nWidth  = rc.right-rc.left;
	LONG nHeight = rc.bottom-rc.top;

	LONG nX = (GetSystemMetrics(SM_CXSCREEN)-nWidth)/2;
	LONG nY = (GetSystemMetrics(SM_CYSCREEN)-nHeight)/2;

	char szBuf[256];
	GetModuleFileName( hInstance, szBuf, 256 );
	_splitpath( szBuf, NULL, NULL, szTitle, NULL );

	hWnd = CreateWindow(WINDOW_CLASS, szTitle, WINDOW_STYLE,
      nX, nY, nWidth, nHeight, NULL, NULL, hInstance, NULL);

	if( !hWnd ) 
	{
		return FALSE;
	}

	ShowWindow( hWnd, nCmdShow );
	UpdateWindow( hWnd );

	GetWindowRect( hWnd, &rcWindow );

	return TRUE;
}


//
//  ֐: WndProc(HWND, unsigned, WORD, LONG)
//
//  pr: C EBhẼbZ[W܂B
//
//  WM_COMMAND	- AvP[V j[̏
//  WM_PAINT	- C EBhE̕`
//  WM_DESTROY	- IbZ[W̒ʒmƃ^[
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{

	switch( message ) 
	{
		case WM_KEYDOWN:

			switch( wParam )
			{
			case VK_ESCAPE:

				// I
				SendMessage( hWnd, WM_CLOSE, NULL, NULL );
				break;
			case VK_F4:

				// fBXvCύX
				if( lpDDCliper ){ lpDDCliper->Release(); lpDDCliper = NULL; }
				if( lpDDSBack ){ lpDDSBack->Release(); lpDDSBack = NULL; }
				if( lpDDSPrimary ){ lpDDSPrimary->Release(); lpDDSPrimary = NULL; }

				if( bWindowed )
				{
					GetWindowRect( hWnd, &rcWindow );
				}

				bWindowed ^= 1;

				try
				{
					InitDirectDraw( hWnd );
				}

				// G[
				catch( exception& e )
				{
					ShowWindow( hWnd, SW_HIDE );
					MessageBox( hWnd, e.what(), szTitle, MB_OK | MB_ICONSTOP );
					SendMessage( hWnd, WM_CLOSE, NULL, NULL );
				}
				break;
			}
			break;
		case WM_PAINT:
			
			ValidateRect( hWnd, NULL );
			// TODO: ̈ʒuɕ`p̃R[hǉĂ...
			
			OnRefresh();

			break;
		case WM_MOVE:

			// ]̈擾
			GetClientRect( hWnd, &rcClient);
			ClientToScreen( hWnd, ( LPPOINT )&rcClient );
			ClientToScreen( hWnd,( LPPOINT )&rcClient+1);
			break;
		case WM_DESTROY:
			PostQuitMessage( 0 );
			break;
		default:
			return DefWindowProc( hWnd, message, wParam, lParam );
   }
   return 0;
}


//
//  ֐: InitDirectDraw( HWND hWnd, BOOL bWindowed )
//
//  pr: DirectDraw
//
VOID InitDirectDraw( HWND hWnd )
{

	// DirectDraw7IuWFNg쐬
	if( lpDD == NULL )
	{
		DirectDrawCreateEx( DDRAW_MODE, (LPVOID*)&lpDD, IID_IDirectDraw7, NULL );

		if( lpDD == NULL )

			throw exception("DirectDraw7IuWFNg쐬s"); 
	}

	HRESULT hr;

	if( bWindowed )
	{
		// fBXvC[h
		lpDD->RestoreDisplayMode();

		// EBhEX^CύX
		SetWindowLong( hWnd, GWL_STYLE, WINDOW_STYLE );

		// EBh|WV
		SetWindowPos( hWnd, NULL, rcWindow.left, rcWindow.top, 
			rcWindow.right-rcWindow.left, rcWindow.bottom-rcWindow.top,
					 SWP_NOZORDER | SWP_NOACTIVATE | SWP_DRAWFRAME );

		// xݒ
		hr = lpDD->SetCooperativeLevel( hWnd, DDSCL_NORMAL );

		if( FAILED( hr ) )
		{
			throw exception("DirectDraw7x̐ݒ莸s");
		}

		DDSURFACEDESC2 ddsd = { 0 };

		// vC}[T[tFCX쐬
		ddsd.dwSize  = sizeof( DDSURFACEDESC2 );
		ddsd.dwFlags = DDSD_CAPS;
		ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE | DDRAW_MEMORYTYPE;

		hr = lpDD->CreateSurface( &ddsd, &lpDDSPrimary, NULL );

		if( FAILED( hr ) )
		{
			throw exception("DirectDraw7vC}[T[tFCX쐬s");
		}
/*
		// ZJ_T[tFCX쐬
		ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN | DDRAW_MEMORYTYPE;
		ddsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT;
		ddsd.dwWidth = CLIENT_WIDTH;
		ddsd.dwHeight = CLIENT_HEIGHT;
		
		hr = lpDD->CreateSurface( &ddsd, &lpDDSBack, NULL );

		if( FAILED( hr ) )
		{
			throw exception("DirectDraw7ZJ_[T[tFCX쐬s");
		}
*/
		// Nbp[̍쐬
		hr = lpDD->CreateClipper( NULL, &lpDDCliper, NULL );

		if( FAILED( hr ) )
		{
			throw exception( "DirectDraw7Nbp[쐬s" );
		}
		
		// Nbp[ɃEBhEnh֘AÂ
		hr = lpDDCliper->SetHWnd( NULL, hWnd );

		if( FAILED( hr ) )
		{
			throw exception( "DirectDraw7Nbp[EBhEnhݒ莸s" );
		}

		// Nbp[̐ݒ
		hr = lpDDSPrimary->SetClipper( lpDDCliper );

		if( FAILED( hr ) )
		{
			throw exception( "DirectDraw7Nbp[ݒ莸s");
		}

	}else
	{
		// EBhEX^CύX
		SetWindowLong( hWnd, GWL_STYLE, WS_POPUP );

		// xݒ
		hr = lpDD->SetCooperativeLevel( hWnd, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN | DDSCL_ALLOWREBOOT );

		if( FAILED( hr ) )
		{
			throw exception("DirectDraw7x̐ݒ莸s");
		}

		// fBXvC[hݒ
		hr = lpDD->SetDisplayMode( CLIENT_WIDTH, CLIENT_HEIGHT, 16, NULL, NULL );

		if( FAILED( hr ) )
		{
			throw exception("DirectDraw7fBXvC[hݒ莸s");
		}


		DDSURFACEDESC2 ddsd = { 0 };

		// vC}[T[tFCX쐬
		ddsd.dwSize  = sizeof( DDSURFACEDESC2 );
/*		ddsd.dwFlags = DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
		ddsd.dwBackBufferCount = 1;
		ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE | DDSCAPS_FLIP | 
								DDSCAPS_COMPLEX | DDRAW_MEMORYTYPE;
*/
		ddsd.dwFlags = DDSD_CAPS;
		ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE | DDRAW_MEMORYTYPE;

		hr = lpDD->CreateSurface( &ddsd, &lpDDSPrimary, NULL );

		if( FAILED( hr ) )
		{
			throw exception("DirectDraw7vC}[T[tFCX쐬s");
		}
/*/
		// ZJ_T[tFCX쐬
		ddsd.ddsCaps.dwCaps = DDSCAPS_BACKBUFFER;

		lpDDSPrimary->GetAttachedSurface( &ddsd.ddsCaps, &lpDDSBack );

		if( FAILED( hr ) )
		{
			throw exception("DirectDraw7ZJ_[T[tFCX쐬s");
		}
*/
	}

}


//
//  ֐: UnInitDirectDraw( void )
//
//  pr: DirectDraw񏉊
//
VOID UnInitDirectDraw( VOID )
{
	// fBXvC[h
	if( lpDD && !bWindowed ){ lpDD->RestoreDisplayMode(); }

	if( lpDDCliper ){ lpDDCliper->Release(); lpDDCliper = NULL; }
	if( lpDDSBack ){ lpDDSBack->Release(); lpDDSBack = NULL; }
	if( lpDDSPrimary ){ lpDDSPrimary->Release(); lpDDSPrimary = NULL; }
	if( lpDD ){ lpDD->Release(); lpDD = NULL; }

}


//
//  ֐: DrawSDib32GLInfo( LPSDIB32GL lpBack )
//
//  pr: SDIB32GL̏`悵܂B
//
VOID DrawSDib32GLInfo( LPSDIB32GL lpBack )
{

	FpsTimer.WaitFrame();

	char szBuf[256];

	sprintf( szBuf, "FPS: %6.2f / MMX: %s / Version: %4.2f / ChangeScreen F4", 
		FpsTimer.GetFPS(FPSTIMER_F_FPS,true), SDIB32GL_IsMMX()?"YES":"NO", SDIB32GL_GetVersion()/100.f );

	SetBkMode( lpBack->GetDC(), TRANSPARENT );
	SetTextColor( lpBack->GetDC(), RGB(255,0,0) );
	TextOut( lpBack->GetDC(), 0, 0, szBuf, strlen(szBuf));
}