// Graphic.cpp : AvP[Vp̃Gg |Cg̒`
//

#include "stdafx.h"

#include "SDIB32GL.H"
#include "util.h"

LPSDIB32GL lpBack	= NULL;
LPSDIB32GL lpBg		= NULL;


int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow )
{
 	// TODO: ̈ʒuɃR[hLqĂB

	MyRegisterClass( hInstance );

	if( !InitInstance( hInstance, nCmdShow ) )
	{
		return FALSE;
	}


	// MMX̔
	BOOL bMMX = SDIB32GL_IsMMX();

	const CLSID* pUse_CLSID;

	if( bMMX )
	{
		pUse_CLSID = &CLSID_SDib32GLPMMX;

	}else
	{
		pUse_CLSID = &CLSID_SDib32GLX86;
	}
	
	HRESULT hr;

	try
	{
		// obNobt@̍쐬
		hr = SDIB32GL_CreateBuffer( 
			CLIENT_WIDTH, CLIENT_HEIGHT, SDIB32GL_BLUE, NULL,
			*pUse_CLSID, IID_ISDib32GL, (LPVOID*)&lpBack );

		if( FAILED( hr ) )
		{
			throw exception("obNobt@̍쐬Ɏs");
		}

		// BGǂݍ
		hr = SDIB32GL_LoadFromFile(
			"../Media/BackGround.bmp", 0, NULL,
			*pUse_CLSID, IID_ISDib32GL, (LPVOID*)&lpBg );

		if( FAILED( hr ) )
		{
			throw exception("t@C̓ǂݍ݂Ɏs");
		}
	}

	// G[
	catch( exception& e )
	{
		
		MessageBox( hWnd, e.what(), szTitle, MB_OK | MB_ICONSTOP );

		if( lpBg ){		lpBg->Release(); lpBg = NULL; }
		if( lpBack ){	lpBack->Release(); lpBack = NULL; }

		return FALSE;
	}


	// bZ[W[v(C[`)
	MSG msg;

	for(;;)
	{
		if( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) )
		{
			if( msg.message == WM_QUIT ) break;

			TranslateMessage( &msg );
			DispatchMessage( &msg );

		}else
		{

			// obNobt@NA
			//lpBack->Clear( SDIB32GL_RGB(150,220,255) );
			lpBack->Blt( lpBg, 0, 0, NULL, NULL, NULL );
			
			int x = (CLIENT_WIDTH-500)/2;
			int y = (CLIENT_HEIGHT-375)/2;

			// `
			lpBack->RectangleAlpha( x, y, 128, 128, SDIB32GL_ARGB(150,255,0,0));
			lpBack->RectangleAdd( x+(500-128)/2, y, 128, 128, SDIB32GL_RGB(255,0,255));
			lpBack->RectangleSub( x+(500-128), y, 128, 128, SDIB32GL_RGB(255,0,255));

			y += (375-128)/2;

			// ȉ~
			lpBack->EllipseAlpha( x+64, y+64, 80, 50, SDIB32GL_ARGB(150,255,0,0));
			lpBack->EllipseAdd( x+(500-128)/2+64, y+64, 80, 50, SDIB32GL_RGB(255,0,255));
			lpBack->EllipseSub( x+(500-128)+64, y+64, 80, 50, SDIB32GL_RGB(255,0,255));
			
			y += (375-128)/2;

			// 
			for( int i = 0; i < 16; i++ )
			{
				int l=i*6;

				lpBack->LineAlpha( x, y+l, x+128, y+64+l, SDIB32GL_ARGB(255-i*16,255,0,0));
				lpBack->LineAdd( x+(500-128)/2, y+l, x+(500-128)/2+128, y+64+l, SDIB32GL_ARGB(255-i*16,255,0,255));
				lpBack->LineSub( x+(500-128), y+l, x+(500-128)+128, y+64+l, SDIB32GL_ARGB(255-i*16,255,0,255));

			}

			// FPSAMMXAo[W̕`
			DrawSDib32GLInfo( lpBack );

			// ĕ`
			InvalidateRect( hWnd, NULL, FALSE );
			UpdateWindow( hWnd );
		}
	}

	// BGobt@̉
	lpBg->Release();
	lpBg = NULL;

	// obNobt@̉
	lpBack->Release();
	lpBack = NULL;

	return msg.wParam;
}


//
// ʂ̃tbV
//
void OnRefresh( HDC hdc )
{
	if( lpBack == NULL ) return;

	BitBlt( hdc, 0, 0, CLIENT_WIDTH, CLIENT_HEIGHT, 
		lpBack->GetDC(), 0, 0, SRCCOPY );
}








